//------------------------------------------------------------------------------
// EventDialog.java:
//		Implementation for container control initialization class EventDialog
//
// WARNING: Do not modify this file.  This file is recreated each time its
//          associated .rct/.res file is sent through the Java Resource Wizard!
//
// This class can be use to create controls within any container, however, the
// following describes how to use this class with an Applet.  For addtional
// information on using Java Resource Wizard generated classes, refer to the
// Visual J++ 1.1 documention.
//
// 1) Import this class in the .java file for the Applet that will use it:
//
//      import EventDialog;
//
// 2) Create an instance of this class in your Applet's 'init' member, and call
//    CreateControls() through this object:
//
//      EventDialog ctrls = new EventDialog (this);
//      ctrls.CreateControls();
//
// 3) To process events generated from user action on these controls, implement
//    the 'handleEvent' member for your applet:
//
//      public boolean handleEvent (Event evt)
//      {
//
//      }
//
//------------------------------------------------------------------------------
import java.awt.*;
import DialogLayout;

public class EventDialog
{
	Container    m_Parent       = null;
	boolean      m_fInitialized = false;
	DialogLayout m_Layout;

	// Control definitions
	//--------------------------------------------------------------------------
	Button        IDOK;
	Button        IDCANCEL;
	Label         EventNameLabel1;
	TextField     EventName;
	CheckboxGroup group1;
	Checkbox      FieldEvent;
	Checkbox      TrackMeet;


	// Constructor
	//--------------------------------------------------------------------------
	public EventDialog (Container parent)
	{
		m_Parent = parent;
	}

	// Initialization.
	//--------------------------------------------------------------------------
	public boolean CreateControls()
	{
		// Can only init controls once
		//----------------------------------------------------------------------
		if (m_fInitialized || m_Parent == null)
			return false;

		// Parent must be a derivation of the Container class
		//----------------------------------------------------------------------
		if (!(m_Parent instanceof Container))
			return false;

		// Since there is no way to know if a given font is supported from
		// platform to platform, we only change the size of the font, and not
		// type face name.  And, we only change the font if the dialog resource
		// specified a font.
		//----------------------------------------------------------------------
		Font OldFnt = m_Parent.getFont();
		
		if (OldFnt != null)
		{
			Font NewFnt = new Font(OldFnt.getName(), OldFnt.getStyle(), 8);

			m_Parent.setFont(NewFnt);
		}

		// All position and sizes are in Dialog Units, so, we use the
		// DialogLayout manager.
		//----------------------------------------------------------------------
		m_Layout = new DialogLayout(m_Parent, 272, 146);
		m_Parent.setLayout(m_Layout);
		m_Parent.addNotify();

		Dimension size   = m_Layout.getDialogSize();
		Insets    insets = m_Parent.insets();
		
		m_Parent.resize(insets.left + size.width  + insets.right,
                        insets.top  + size.height + insets.bottom);

		// Control creation
		//----------------------------------------------------------------------
		IDOK = new Button ("OK");
		m_Parent.add(IDOK);
		m_Layout.setShape(IDOK, 215, 7, 50, 14);

		IDCANCEL = new Button ("Cancel");
		m_Parent.add(IDCANCEL);
		m_Layout.setShape(IDCANCEL, 215, 24, 50, 14);

		EventNameLabel1 = new Label ("Event Name:", Label.LEFT);
		m_Parent.add(EventNameLabel1);
		m_Layout.setShape(EventNameLabel1, 7, 15, 48, 9);

		EventName = new TextField ("");
		m_Parent.add(EventName);
		m_Layout.setShape(EventName, 57, 13, 86, 14);

		group1 = new CheckboxGroup ();
		FieldEvent = new Checkbox ("Field Event", group1, false);
		m_Parent.add(FieldEvent);
		m_Layout.setShape(FieldEvent, 21, 49, 63, 10);

		TrackMeet = new Checkbox ("Track Meet", group1, false);
		m_Parent.add(TrackMeet);
		m_Layout.setShape(TrackMeet, 20, 62, 58, 10);

		m_fInitialized = true;
		return true;
	}
}
