//------------------------------------------------------------------------------
// EventPropertiesDialog.java:
//		Implementation for container control initialization class EventPropertiesDialog
//
// WARNING: Do not modify this file.  This file is recreated each time its
//          associated .rct/.res file is sent through the Java Resource Wizard!
//
// This class can be use to create controls within any container, however, the
// following describes how to use this class with an Applet.  For addtional
// information on using Java Resource Wizard generated classes, refer to the
// Visual J++ 1.1 documention.
//
// 1) Import this class in the .java file for the Applet that will use it:
//
//      import EventPropertiesDialog;
//
// 2) Create an instance of this class in your Applet's 'init' member, and call
//    CreateControls() through this object:
//
//      EventPropertiesDialog ctrls = new EventPropertiesDialog (this);
//      ctrls.CreateControls();
//
// 3) To process events generated from user action on these controls, implement
//    the 'handleEvent' member for your applet:
//
//      public boolean handleEvent (Event evt)
//      {
//
//      }
//
//------------------------------------------------------------------------------
import java.awt.*;
import DialogLayout;

public class EventPropertiesDialog
{
	Container    m_Parent       = null;
	boolean      m_fInitialized = false;
	DialogLayout m_Layout;

	// Control definitions
	//--------------------------------------------------------------------------
	CheckboxGroup group1;
	Checkbox      FieldEvent;
	Checkbox      TrackEvent;
	Checkbox      HeatSheet;
	CheckboxGroup group2;
	Checkbox      Distance;
	Checkbox      Time;
	Button        ScoreProperties;
	Checkbox      TrialEnable;
	TextField     NumTrials;
	Label         TrialsLabel;
	Label         BestScoreLabel1;
	CheckboxGroup group3;
	Checkbox      LowestScore;
	Checkbox      HighestScore;
	Label         BestScoreLabel2;
	Checkbox      InTeamTotal;
	Checkbox      Done;
	Label         QualifyingScoreLabel;
	TextField     QualifyingScore;
	Button        ApplyHeatSheet;
	Label         HighestLabel;
	TextField     Highest;
	Label         LowestLabel;
	TextField     Lowest;
	Label         IncrementLabel;
	TextField     Increment;
	Button        IDOK;
	Button        IDCANCEL;
	Label         EventTypeGroup;
	Label         ScoreTypeGroup;
	Label         ScoringGroup10;
	Label         StatusGroup;
	Label         QualificationGroup;
	Label         PointsGroup;


	// Constructor
	//--------------------------------------------------------------------------
	public EventPropertiesDialog (Container parent)
	{
		m_Parent = parent;
	}

	// Initialization.
	//--------------------------------------------------------------------------
	public boolean CreateControls()
	{
		// Can only init controls once
		//----------------------------------------------------------------------
		if (m_fInitialized || m_Parent == null)
			return false;

		// Parent must be a derivation of the Container class
		//----------------------------------------------------------------------
		if (!(m_Parent instanceof Container))
			return false;

		// Since there is no way to know if a given font is supported from
		// platform to platform, we only change the size of the font, and not
		// type face name.  And, we only change the font if the dialog resource
		// specified a font.
		//----------------------------------------------------------------------
		Font OldFnt = m_Parent.getFont();
		
		if (OldFnt != null)
		{
			Font NewFnt = new Font(OldFnt.getName(), OldFnt.getStyle(), 8);

			m_Parent.setFont(NewFnt);
		}

		// All position and sizes are in Dialog Units, so, we use the
		// DialogLayout manager.
		//----------------------------------------------------------------------
		m_Layout = new DialogLayout(m_Parent, 312, 180);
		m_Parent.setLayout(m_Layout);
		m_Parent.addNotify();

		Dimension size   = m_Layout.getDialogSize();
		Insets    insets = m_Parent.insets();
		
		m_Parent.resize(insets.left + size.width  + insets.right,
                        insets.top  + size.height + insets.bottom);

		// Control creation
		//----------------------------------------------------------------------
		group1 = new CheckboxGroup ();
		FieldEvent = new Checkbox ("Field Event", group1, false);
		m_Parent.add(FieldEvent);
		m_Layout.setShape(FieldEvent, 13, 18, 63, 10);

		TrackEvent = new Checkbox ("TrackEvent", group1, false);
		m_Parent.add(TrackEvent);
		m_Layout.setShape(TrackEvent, 13, 31, 58, 10);

		HeatSheet = new Checkbox ("Heat Sheet", group1, false);
		m_Parent.add(HeatSheet);
		m_Layout.setShape(HeatSheet, 13, 44, 52, 10);

		group2 = new CheckboxGroup ();
		Distance = new Checkbox ("Distance", group2, false);
		m_Parent.add(Distance);
		m_Layout.setShape(Distance, 109, 19, 44, 10);

		Time = new Checkbox ("Time", group2, false);
		m_Parent.add(Time);
		m_Layout.setShape(Time, 109, 31, 31, 10);

		ScoreProperties = new Button ("Score Properties");
		m_Parent.add(ScoreProperties);
		m_Layout.setShape(ScoreProperties, 108, 44, 64, 14);

		TrialEnable = new Checkbox ("Use the best of");
		m_Parent.add(TrialEnable);
		m_Layout.setShape(TrialEnable, 13, 89, 64, 10);

		NumTrials = new TextField ("");
		m_Parent.add(NumTrials);
		m_Layout.setShape(NumTrials, 79, 87, 40, 14);

		TrialsLabel = new Label ("trials for final score", Label.LEFT);
		m_Parent.add(TrialsLabel);
		m_Layout.setShape(TrialsLabel, 123, 90, 59, 8);

		BestScoreLabel1 = new Label ("The best score is the", Label.LEFT);
		m_Parent.add(BestScoreLabel1);
		m_Layout.setShape(BestScoreLabel1, 13, 106, 67, 8);

		group3 = new CheckboxGroup ();
		LowestScore = new Checkbox ("lowest", group3, false);
		m_Parent.add(LowestScore);
		m_Layout.setShape(LowestScore, 84, 106, 36, 10);

		HighestScore = new Checkbox ("highest", group3, false);
		m_Parent.add(HighestScore);
		m_Layout.setShape(HighestScore, 120, 106, 39, 10);

		BestScoreLabel2 = new Label ("score", Label.LEFT);
		m_Parent.add(BestScoreLabel2);
		m_Layout.setShape(BestScoreLabel2, 163, 106, 18, 8);

		InTeamTotal = new Checkbox ("Include this event with the team totals");
		m_Parent.add(InTeamTotal);
		m_Layout.setShape(InTeamTotal, 13, 140, 135, 10);

		Done = new Checkbox ("This event has been entered and verified");
		m_Parent.add(Done);
		m_Layout.setShape(Done, 13, 152, 145, 10);

		QualifyingScoreLabel = new Label ("Score:", Label.LEFT);
		m_Parent.add(QualifyingScoreLabel);
		m_Layout.setShape(QualifyingScoreLabel, 201, 62, 22, 8);

		QualifyingScore = new TextField ("");
		m_Parent.add(QualifyingScore);
		m_Layout.setShape(QualifyingScore, 225, 59, 70, 14);

		ApplyHeatSheet = new Button ("Apply Heat Sheet");
		m_Parent.add(ApplyHeatSheet);
		m_Layout.setShape(ApplyHeatSheet, 201, 81, 95, 14);

		HighestLabel = new Label ("Highest:", Label.LEFT);
		m_Parent.add(HighestLabel);
		m_Layout.setShape(HighestLabel, 201, 119, 27, 8);

		Highest = new TextField ("");
		m_Parent.add(Highest);
		m_Layout.setShape(Highest, 240, 116, 53, 14);

		LowestLabel = new Label ("Lowest:", Label.LEFT);
		m_Parent.add(LowestLabel);
		m_Layout.setShape(LowestLabel, 201, 137, 26, 8);

		Lowest = new TextField ("");
		m_Parent.add(Lowest);
		m_Layout.setShape(Lowest, 240, 134, 53, 14);

		IncrementLabel = new Label ("Increment:", Label.LEFT);
		m_Parent.add(IncrementLabel);
		m_Layout.setShape(IncrementLabel, 201, 154, 34, 8);

		Increment = new TextField ("");
		m_Parent.add(Increment);
		m_Layout.setShape(Increment, 240, 152, 53, 14);

		IDOK = new Button ("OK");
		m_Parent.add(IDOK);
		m_Layout.setShape(IDOK, 254, 7, 50, 14);

		IDCANCEL = new Button ("Cancel");
		m_Parent.add(IDCANCEL);
		m_Layout.setShape(IDCANCEL, 254, 24, 50, 14);

		EventTypeGroup = new Label ("Event Type:", Label.LEFT);
		m_Parent.add(EventTypeGroup);
		m_Layout.setShape(EventTypeGroup, 7, 7, 40, 8);

		ScoreTypeGroup = new Label ("Score Type:", Label.LEFT);
		m_Parent.add(ScoreTypeGroup);
		m_Layout.setShape(ScoreTypeGroup, 102, 7, 40, 8);

		ScoringGroup10 = new Label ("Scoring:", Label.LEFT);
		m_Parent.add(ScoringGroup10);
		m_Layout.setShape(ScoringGroup10, 7, 76, 27, 8);

		StatusGroup = new Label ("Status:", Label.LEFT);
		m_Parent.add(StatusGroup);
		m_Layout.setShape(StatusGroup, 7, 130, 23, 8);

		QualificationGroup = new Label ("Qualification:", Label.LEFT);
		m_Parent.add(QualificationGroup);
		m_Layout.setShape(QualificationGroup, 196, 46, 42, 8);

		PointsGroup = new Label ("Points:", Label.LEFT);
		m_Parent.add(PointsGroup);
		m_Layout.setShape(PointsGroup, 196, 104, 22, 8);

		m_fInitialized = true;
		return true;
	}
}
