import java.io.*;
-----import java.awt.*;

class TreeItem extends Object
{
  public TreeItem children[];
  public int numChildren;
  public String name;
  public int level;
  public boolean expanded;
  public Object value;

  public TreeItem(String name, Object value, int level)
  {
    super();
    this.name = name;
    this.value = value;
    this.level = level;
    numChildren = 0;
    expanded = false;
  }

  public void paint(Graphics g, Rectangle rect, int lastLevel, int row)
  {

  }

  public void addNode(StringTokenizer path, Object value)
  {
    if (path.hasMoreTokens())
    {
      // Find the child
      String child = path.nextToken();
      int i = numChildren - 1;
      boolean found = false;
      while ((i >= 0) && !found)
      {
        if (children[i].name.compareTo(child) == 0)
          found = true;
      }

      // If the child was not found, add one to our list :-)
      if (!found)
      {
        TreeItem copy = children;
        String cmp1, cmp2 = child.toLowerCase();
        children = new TreeItem[++numChildren];
        found = false;
        for (i = 0; i < numChildren - 1; i++)
        {
          cmp1 = copy[i].name.toLowerCase();
          if (cmp1.compareTo(cmp2) > 0)
          {
            found = true;
            children[i] = new TreeItem(child, value, level + 1);
            children[i].addNode(path, value);
          }
          else
          {
            children[((found)? i + 1: i)] = copy[i];
            i++;
          }
        }

        // If this is the last item, add it to the end
        if (!found)
        {
          children[numChildren - 1] = new TreeItem(child, value, level + 1);
          children[numChildren - 1].addNode(path, value);
        }
      }

      // The child was found; simply tell the child to create another child
      else
      {
        children[i].addNode(path, value);
      }
    }
  }
}

class Tree extends Canvas
{
  TreeItem root;

  public Tree(String name, Object value)
  {
    super();
    root = new TreeItem(name, value, 0);
  }

  // Adds a node to the tree with the given path, delimited with |
  public void addNode(String path, Object value)
  {
    StringTokenizer str = new StringTokenizer(path, "|", false);
    root.addNode(str, value);
  }

  public void paint(Graphics g)
  {
    // Draw a white rectangle in the damaged area
    Rectangle rect = g.getClipRect();
    g.setColor(new Color(255, 255, 255));
    g.fillRect(rect.x, rect.y, rect.width, rect.height);

    // Set the device context's font to MS Sans Serif, 8 pt
    g.setFont(new Font("MS Sans Serif", Font.PLAIN, 8));

    // Notify the tree about this message
    root.paint(g, rect, 0, 0);
  }
}

public class TreeTest implements Runnable
{
  public void run()
  {
  }

  public static void main(String args[])
  {
    Window wnd = new Window();

  }
}
