class ttDate extends DBObject
{
  // Values for this object
  public int year;
  public int month;
  public int weekDay;
  public int day;
  public int hour;
  public int minute;
  public boolean includeWeekDay;
  public boolean includeTime;

  // String representations
  String monthStr[] = { "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" };
  String weekDayStr[] = { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" };

  private void createDateType(int year, int month, int day, int hour, int minute, boolean includeWeekDay)
  {
    // Assign the variables of this object
    this.year = year;
    this.month = month;
    this.day = day;
    this.hour = hour;
    this.minute = minute;
    this.includeWeekDay = includeWeekDay;

    // Determine the day of the week
/*    GregorianCalendar weekDay = new GregorianCalendar(year, month, day);
    weekDay.complete();
    this.weekDay = weekDay.get(Calendar.DAYOFWEEK) - Calendar.SUNDAY; Java 1.1*/
    Date weekDay = new Date(year, month, day);
    this.weekDay = weekDay.getDay();

    // Set flags
    includeTime = true;
  }

  public ttDate(int year, int month, int day, int hour, int minute, boolean includeWeekDay)
  {
    // Assign the new date variables
    super();
    createDateType(year, month, day, hour, minute, includeWeekDay);
  }

  public ttDate(int year, int month, int day, int hour, int minute)
  {
    // Programmer didn't specify the weekDay flag; assume false
    super();
    createDateType(year, month, day, hour, minute, false);
  }

  public ttDate(int year, int month, int day)
  {
    // Programmer is too lazy to add two zeros, so I must do it
    super();
    createDateType(year, month, day, 0, 0, false);
    includeTime = false;
  }

  public ttDate()
  {
    // Programmer was REALLY lazy!!  It is now January 1, 1997
    super();
    createDateType(1997, 0, 0, 0, 0, false);
    includeTime = false;
  }

  public String toString()
  {
    // Convert myself into a string
    return ((includeWeekDay)? weekDayStr[weekDay] + ", ": "") + monthStr[month] +
           " " + java.lang.String.valueOf(day + 1) + ", " + java.lang.String.valueOf(year) + 
           ((includeTime)? "  " + java.lang.String.valueOf((hour == 0)? 12: (hour + 1) % 12) + ":" + java.lang.String.valueOf(minute + 1) +
           ((hour >= 12)? "PM": "AM"): "");
  }

  public void setValue(long value)
  {
    // Set the values
    year = (int) value / (13 * 32 * 25 * 61);
    value = value % (13 * 32 * 25 * 61);

    month = (int) value / (32 * 25 * 61);
    value = value % (32 * 25 * 61);

    day = (int) value / (25 * 61);
    value = value % (25 * 61);

    hour = (int) value / 61;
    value = value % 61;

    minute = (int) value;

    // Determine the day of the week
/*    GregorianCalendar weekDay = new GregorianCalendar(year, month, day);
    weekDay.complete();
    this.weekDay = weekDay.get(Calendar.DAYOFWEEK) - Calendar.SUNDAY; Java 1.1*/
    Date weekDay = new Date(year, month, day);
    this.weekDay = weekDay.getDay();
  }

  public static long getSetValue(int year, int month, int day, int hour, int minute)
  {
    // Convert ourselves into minutes for the setValue() function
    long minutes;
    minutes = year * 13 * 32 * 25 * 61;
    minutes += month * 32 * 25 * 61;
    minutes += day * 25 * 61;
    minutes += hour * 61;
    minutes += minute;
    return minutes;
  }

  public int compareTo(DBObject other)
  {
    // Get the number of minutes in both dates
    long otherValue = other.getLongValue();
    long thisValue = this.getLongValue();

    // This time is less than the other time
    if (otherValue > thisValue)
      return -1;

    // This time equals the other time
    if (otherValue == thisValue)
      return 0;

    // This time is greater than the other time
      return 1;
  }

  public long getLongValue()
  {
    // Convert ourselves into minutes; only use this result with DateType functions!!
    long minutes;
    minutes = year * 12 * 31 * 24 * 60;
    minutes += month * 31 * 24 * 60;
    minutes += day * 24 * 60;
    minutes += hour * 60;
    minutes += minute;
    return minutes;
  }

  public String getStringValue()
  {
    return String.valueOf(getSetValue(year, month, day, hour, minute));
  }

  public void setValue(String value)
  {
    long lValue = java.lang.Long.parseLong(value);
    setValue(lValue);
  }

  public void load(InputStream in)
  {
    // Load our variables from the input stream
    in.read(year, 0, sizeof(year));
    in.read(month, 0, sizeof(month));
    in.read(day, 0, sizeof(day));
    in.read(weekDay, 0, sizeof(weekDay));
    in.read(hour, 0, sizeof(hour));
    in.read(minute, 0, sizeof(minute));
    in.read(includeWeekDay, 0, sizeof(includeWeekDay));
    in.read(includeTime, 0, sizeof(includeWeekDay));
  }

  public void save(OutputStream out)
  {
    // Save our variables into the output stream
    out.write(year, 0, sizeof(year));
    out.write(month, 0, sizeof(month));
    out.write(day, 0, sizeof(day));
    out.write(weekDay, 0, sizeof(weekDay));
    out.write(hour, 0, sizeof(hour));
    out.write(minute, 0, sizeof(minute));
    out.write(includeWeekDay, 0, sizeof(includeWeekDay));
    out.write(includeTime, 0, sizeof(includeTime));
  }

  public void read(OutputStream out)
  {
    // Write our data to out
    out.write(year, 0, sizeof(year));
    out.write(month, 0, sizeof(month));
    out.write(day, 0, sizeof(day));
    out.write(weekDay, 0, sizeof(weekDay));
    out.write(hour, 0, sizeof(hour));
    out.write(minute, 0, sizeof(minute));
    out.write(includeWeekDay, 0, sizeof(includeWeekDay));
    out.write(includeTime, 0, sizeof(includeTime));
    out.write(ClientThread.OK);
  }

  public void write(OutputStream out)
  {
    // Read this information from the parameters
    parms.read(year, 0, sizeof(year));
    parms.read(month, 0, sizeof(month));
    parms.read(day, 0, sizeof(day));
    parms.read(weekDay, 0, sizeof(weekDay));
    parms.read(hour, 0, sizeof(hour));
    parms.read(minute, 0, sizeof(minute));
    parms.read(includeWeekDay, 0, sizeof(includeWeekDay));
    parms.read(includeTime, 0, sizeof(includeTime));
    out.write(ClientThread.OK);
  }
}

class ttDist extends DBObject
{
  // Values for this object
  private long english;  // in 1/16 inches
  private long metric;   // in millimeters
  public boolean useMetric;

  // Display flags
  public boolean includeHuge;   // kilometers and miles
  public boolean includeLarge;  // meters and yards
  public boolean includeMedium; // decimeters and feet
  public boolean includeSmall;  // centimeters and inches
  public boolean includeTiny;   // millimeters and fractions of inches

  public ttDist(long distance, boolean useMetric)
  {
    // Set this distance's value to the given distance and set the system
    super();
    this.useMetric = useMetric;
    this.metric = (useMetric)? distance: metricValue(distance);
    this.english = (useMetric)? englishValue(distance): distance;
    includeHuge = false;
    includeLarge = true;
    includeMedium = (useMetric)? false: true;
    includeSmall = true;
    includeTiny = false;
  }

  public ttDist(long distance)
  {
    // Set this distance's value to the given distance and use metric
    super();
    this.useMetric = true;
    this.metric = (useMetric)? distance: metricValue(distance);
    this.english = (useMetric)? englishValue(distance): distance;
    includeHuge = false;
    includeLarge = true;
    includeMedium = (useMetric)? false: true;
    includeSmall = true;
    includeTiny = false;
  }

  public ttDist()
  {
    // Set this distance's value to zero and assume metric
    super();
    this.useMetric = true;
    this.metric = 0;
    this.english = 0;
    includeHuge = false;
    includeLarge = true;
    includeMedium = (useMetric)? false: true;
    includeSmall = true;
    includeTiny = false;
  }

  public long getValue(boolean getMetric)
  {
    // Return the desired variable
    return (getMetric)? metric: english;
  }

  public void setValue(long distance, boolean useMetric)
  {
    // Set this distance's value to the given distance and set the current system
    this.useMetric = useMetric;
    this.metric = (useMetric)? distance: metricValue(distance);
    this.english = (useMetric)? englishValue(distance): distance;
  }

  public void setValue(long distance)
  {
    // Set this distance's value to the given distance in the current system
    this.metric = (useMetric)? distance: metricValue(distance);
    this.english = (useMetric)? englishValue(distance): distance;
  }

  public long englishValue(long metric)
  {
    // Convert millimeters into 1/16 inches
    return (long) (metric / 1.5875);
  }

  public long metricValue(long english)
  {
    // Convert 1/16 inches into millimeters
    return (long) (english * 1.5875);
  }

  public String toString()
  {
    // Convert myself into a string
    if (useMetric)
    {
      // Display with the metric system
      String output = new String();
      long distance = metric;

      if (includeHuge)
      {
        output = output.concat(java.lang.String.valueOf(distance / 1000000) + "km ");
        distance = distance % 1000000;
      }

      if (includeLarge)
      {
        output =  output.concat(java.lang.String.valueOf(distance / 1000) + "m ");
        distance = distance % 1000;
      }

      if (includeMedium)
      {
        output = output.concat(java.lang.String.valueOf(distance / 100) + "dm ");
        distance = distance % 100;
      }

      if (includeSmall)
      {
        output = output.concat(java.lang.String.valueOf(distance / 10) + "cm ");
        distance = distance % 10;
      }

      if (includeTiny)
        output = output.concat(java.lang.String.valueOf(distance) + "mm");

      // Remove the ending space (if any)
      output = output.trim();

      return output;
    }
    else
    {
      // Display with the english system
      String output = new String();
      long distance = english;

      if (includeHuge)
      {
        output = output.concat(java.lang.String.valueOf(distance / 1013760) + "mi ");
        distance = distance % 1013760;
      }

      if (includeLarge)
      {
        output = output.concat(java.lang.String.valueOf(distance / 576) + "yd ");
        distance = distance % 576;
      }

      if (includeMedium)
      {
        output = output.concat(java.lang.String.valueOf(distance / 192) + "'");
        distance = distance % 192;
      }

      if (includeSmall)
      {
        output = output.concat(java.lang.String.valueOf(distance / 16) + ((!includeTiny)? "\"": ""));
        distance = distance % 16;
      }

      if (includeTiny)
      {
        if (distance != 0)
        {
          // Write a simplified fraction
          if (distance % 8 == 0)
            output = output.concat(" 1/2\"");
          else
            if (distance % 4 == 0)
              output = output.concat(" " + java.lang.String.valueOf(distance / 4) + "/4\"");
            else
              if (distance % 2 == 0)
                output = output.concat(" " + java.lang.String.valueOf(distance / 2) + "/8\"");
              else
                output = output.concat(" " + java.lang.String.valueOf(distance) + "/16\"");
        }
        else
          if (includeSmall)
            output = output.concat("\"");
      }

      // Remove the ending space (if any)
      output = output.trim();

      return output;
    }
  } /* toString */

  public int compareTo(DBObject other)
  {
    // Get the number of minutes in both dates
    long otherValue = other.getLongValue();
    long thisValue = this.getLongValue();

    // This time is less than the other time
    if (otherValue > thisValue)
      return -1;

    // This time equals the other time
    if (otherValue == thisValue)
      return 0;

    // This time is greater than the other time
    return 1;
  }

  public String getStringValue()
  {
    return String.valueOf((useMetric)? metric: english);
  }

  public void setValue(String value)
  {
    long lValue = java.lang.Long.parseLong(value);
    setValue(lValue);
  }

  public long getLongValue()
  {
    // Return the desired variable in the current system
    return (useMetric)? metric: english;
  }

  public void load(InputStream in)
  {
    in.read(metric, 0, sizeof(metric));
    in.read(english, 0, sizeof(english));
    in.read(useMetric, 0, sizeof(useMetric));
    in.read(includeHuge, 0, sizeof(includeHuge));
    in.read(includeLarge, 0, sizeof(includeLarge));
    in.read(includeMedium, 0, sizeof(includeMedium));
    in.read(includeSmall, 0, sizeof(includeSmall));
    in.read(includeTiny, 0, sizeof(includeTiny));
  }

  public void save(OutputStream out)
  {
    out.write(metric, 0, sizeof(metric));
    out.write(english, 0, sizeof(english));
    out.write(useMetric, 0, sizeof(useMetric));
    out.write(includeHuge, 0, sizeof(includeHuge));
    out.write(includeLarge, 0, sizeof(includeLarge));
    out.write(includeMedium, 0, sizeof(includeMedium));
    out.write(includeSmall, 0, sizeof(includeSmall));
    out.write(includeTiny, 0, sizeof(includeTiny));
  }

  public void read(OutputStream out)
  {
    out.write(metric, 0, sizeof(metric));
    out.write(english, 0, sizeof(english));
    out.write(useMetric, 0, sizeof(useMetric));
    out.write(includeHuge, 0, sizeof(includeHuge));
    out.write(includeLarge, 0, sizeof(includeLarge));
    out.write(includeMedium, 0, sizeof(includeMedium));
    out.write(includeSmall, 0, sizeof(includeSmall));
    out.write(includeTiny, 0, sizeof(includeTiny));
    out.write(ClientThread.OK);
  }

  public void write(OutputStream out)
  {
    parms.read(metric, 0, sizeof(metric));
    parms.read(english, 0, sizeof(english));
    parms.read(useMetric, 0, sizeof(useMetric));
    parms.read(includeHuge, 0, sizeof(includeHuge));
    parms.read(includeLarge, 0, sizeof(includeLarge));
    parms.read(includeMedium, 0, sizeof(includeMedium));
    parms.read(includeSmall, 0, sizeof(includeSmall));
    parms.read(includeTiny, 0, sizeof(includeTiny));
    out.write(ClientThread.OK);
  }
}

class ttStr extends DBObject
{
  // Value for this object
  public String value;

  public ttStr(String value)
  {
    super();
    this.value = new String(value);
  }

  public ttStr()
  {
    super();
    value = new String();
  }

  public String toString()
  {
    // Return ourselves :-)
    return new String(value);
  }

  public int compareTo(DBObject other)
  {
    // Get the number of minutes in both dates
    String otherValue = (other.getStringValue()).toLowerCase();
    String thisValue = value.toLowerCase();

    // Call the string's compareTo function and return that
    return thisValue.compareTo(otherValue);
  }

  public long getLongValue()
  {
    return Long.parseLong(value);
  }

  public String getStringValue()
  {
    return new String(this.value);
  }

  public void setValue(long value)
  {
    // Set the value
    this.value = (new Long(value)).toString();
  }

  public void setValue(String value)
  {
    this.value = new String(value);
  }

  public void load(InputStream in)
  {
    // Load the string from the input
    char str[];
    int len;
    in.read(len, 0, sizeof(len));
    in.read(str, 0, len);
    str[len] = '\0';
    value = new String(str);
  }

  public void save(OutputStream out)
  {
    // Save this string
    char str[] = value.toCharArray();
    int len = value.length();
    out.write(len, 0, sizeof(len));
    out.write(str, 0, len);
  }

  public void read(OutputStream out)
  {
    // Send this string
    char str[] = value.toCharArray();
    int len = value.length();
    out.write(len, 0, sizeof(len));
    out.write(str, 0, len);
    out.write(ClientThread.OK);
  }

  public void write(OutputStream out)
  {
    // Write the client's string to us
    char str[];
    int len;
    parms.read(len, 0, sizeof(len));
    parms.read(str, 0, len);
    str[len] = '\0';
    value = new String(str);
    out.write(ClientThread.OK);
  }
}

class ttTime extends DBObject
{
  // Values for this object
  public long value;

  // Display variables
  public boolean includeHours;
  public boolean includeMinutes;
  public boolean includeSeconds;
  public boolean includeCentiseconds;

  public ttTime(long value)
  {
    // Set this time to the specified value
    super();
    this.value = value;
    includeHours = false;
    includeMinutes = true;
    includeSeconds = true;
    includeCentiseconds = true;
  }

  public ttTime()
  {
    // Set this time to zero values
    super();
    this.value = 0;
    includeMinutes = true;
    includeSeconds = true;
    includeCentiseconds = true;
  }

  public String toString()
  {
     // Convert myself into a string
     String outp = new String();

     long time = this.value;
     if (includeHours)
     {
       outp = outp.concat(java.lang.String.valueOf((long) (time / 360000)) + ((includeMinutes)? ":": "hrs "));
       time = time % 360000;
     }

     if (includeMinutes)
     {
       outp = outp.concat((((time / 6000 < 10) && (includeHours))? "0": "") + java.lang.String.valueOf((long) (time / 6000)) + ((includeSeconds)? ":": "min "));
       time = time % 6000;
     }

     if (includeSeconds)
     {
       outp = outp.concat((((time / 100 < 10) && (includeMinutes))? "0": "") + java.lang.String.valueOf((long) (time / 100)));
       time = time % 100;
     }

     if (includeCentiseconds)
       outp = outp.concat("." + (((time < 10) && (includeSeconds))? "0": "") + java.lang.String.valueOf(time));

     // Remove the ending space (if any)
     outp = outp.trim();

     return outp;
  }

  public int compareTo(DataType other)
  {
    // Get the number of minutes in both dates
    long otherValue = other.getLongValue();
    long thisValue = this.getLongValue();

    // This time is less than the other time
    if (otherValue > thisValue)
      return -1;

    // This time equals the other time
    if (otherValue == thisValue)
      return 0;

    // This time is greater than the other time
    return 1;
  }

  public long getLongValue()
  {
    return value;
  }

  public String getStringValue()
  {
    return String.valueOf(value);
  }

  public void setValue(long value)
  {
    // Set the value
    this.value = value;
  }

  public void setValue(String value)
  {
    this.value = java.lang.Long.parseLong(value);
  }

  public void load(InputStream in)
  {
    in.read(value, 0, sizeof(value));
    in.read(includeHours, 0, sizeof(includeHours));
    in.read(includeMinutes, 0, sizeof(includeMinutes));
    in.read(includeSeconds, 0, sizeof(includeSeconds));
    in.read(includeCentiseconds, 0, sizeof(Centiseconds));
  }

  public void save(OutputStream out)
  {
    out.write(value, 0, sizeof(value));
    out.write(includeHours, 0, sizeof(includeHours));
    out.write(includeMinutes, 0, sizeof(includeMinutes));
    out.write(includeSeconds, 0, sizeof(includeSeconds));
    out.write(includeCentiseconds, 0, sizeof(Centiseconds));
  }

  public void read(OutputStream out)
  {
    out.write(value, 0, sizeof(value));
    out.write(includeHours, 0, sizeof(includeHours));
    out.write(includeMinutes, 0, sizeof(includeMinutes));
    out.write(includeSeconds, 0, sizeof(includeSeconds));
    out.write(includeCentiseconds, 0, sizeof(Centiseconds));
    out.write(ClientThread.OK);
  }

  public void write(OutputStream out)
  {
    parms.read(value, 0, sizeof(value));
    parms.read(includeHours, 0, sizeof(includeHours));
    parms.read(includeMinutes, 0, sizeof(includeMinutes));
    parms.read(includeSeconds, 0, sizeof(includeSeconds));
    parms.read(includeCentiseconds, 0, sizeof(Centiseconds));
    out.write(ClientThread.OK);
  }
}
