// DBPointer.java

package sl.TrackTrek;

import sl.TrackTrek.DBObject;
import java.util.Properties;
import java.util.Hashtable;
import java.io.*;


public class DBPointer extends DBObject
{
  public int id;
  public String folder;
  public int value;

  public DBPointer(String folder, int id, String subFolder)
  {
    this.id = id;
    this.folder = folder + File.pathSeparator + subFolder;
  }

  public DBObject makeNew(String name, String folder, int id)
  {
    // We have no children; return a null pointer
    return null;
  }

  public void load()
  {
    InputStream in = getInputStream(folder, id);
    Properties prop = new Properties();
    try {
      prop.load(in);
    } catch (IOException str) {
      return;
    }
    value = Integer.getInteger(prop.getProperty("value", "0")).intValue();
    try { in.close(); } catch (IOException str) {};
  }

  public void save(DBObject value)
  {
    OutputStream out = getOutputStream(folder, id);
    Properties prop = new Properties();
    prop.put("value", String.valueOf(value));
    prop.save(out, "TrackTrek '97 by Steven Lawrance  DBPointer");
    try { out.close(); } catch (IOException str) {};
  }

  public static Hashtable getTable(Properties prop, String name, String folder)
  {
    int maxval = Integer.valueOf(prop.getProperty(name + ".maxval", "-1")).intValue();
    Hashtable hash = new Hashtable();
    hash.put("maxval", new Integer(maxval));
    int i;
    for (i = 0; i <= maxval; i++)
    {
      if (prop.containsKey(name + "." + String.valueOf(i)))
      {
        DBObject ptr = new DBPointer(folder, i);
        hash.put(String.valueOf(i), ptr);
        ptr.value = Integer.valueOf(prop.getProperty(name + "." + String.valueOf(i), "0")).intValue();
      }
    }
    return hash;
  }
}

