// TrackTrek data type root
// DataType.java
// By Steven Lawrance

package sl.TrackTrek;
import java.lang.String;
import java.lang.Object;
import java.util.Properties;

abstract public class DataType extends Object
{
  // HTML tag info
  public String header;
  public String footer;

  // Convert object into a string
  abstract public String toString();

  // Comparison function
  abstract public int compareTo(DataType other);

  // Value setters/getters
  abstract public void setValue(long value);
  abstract public void setValue(String value);
  abstract public long getLongValue();
  abstract public String getStringValue();
  abstract public void loadProperties(Properties prop, String name);
  abstract public void saveProperties(Properties prop, String name);

  // Sorting algorithm
  public static void sort(DataType array[], int start, int end, boolean ascending)
  {
	 // Sorts from start to end in the array
	 int index, inner, r;
	 DataType temp;

	 if (ascending)
	 {
		// Sort in the ascending order
		for (r = start; r <= end - 1; r++)
		{
		  index = r;
		  for (inner = r + 1; inner <= end; inner++)
			 if (array[inner].compareTo(array[index]) < 0)
				index = inner;
		  if (index != r)
		  {
			 temp = array[index];
			 array[index] = array[r];
			 array[r] = temp;
		  }
		}
	 }
	 else
	 {
		// Sort in the decending order
		for (r = start; r <= end - 1; r++)
		{
		  index = r;
		  for (inner = r + 1; inner <= end; inner++)
			 if (array[inner].compareTo(array[index]) > 0)
				index = inner;
		  if (index != r)
		  {
			 temp = array[index];
			 array[index] = array[r];
			 array[r] = temp;
		  }
		}
	 }
  }

  // Other sorting algorithm
  public static void sort(DataType array[], int numItems, boolean ascending)
  {
	 // Call the sorting procedure to sort from the beginning to the end
	 sort(array, 0, numItems - 1, ascending);
  }

  public DataType()
  {
    header = new String();
    footer = new String();
  }
}


