// Event.java

package sl.TrackTrek;

import sl.TrackTrek.DBObject;
import sl.TrackTrek.StringType;
import sl.TrackTrek.DateType;
import sl.TrackTrek.Score;
import java.util.Properties;
import java.util.Hashtable;
import java.io.*;

public class Event extends DBObject
{
  public Hashtable scores;
  public int id;
  public String folder;
  public StringType name;
  public StringType description;
  public DateType day;

  public Event(String folder, int id)
  {
    this.id = id;
    this.folder = folder + File.pathSeparator + "Events";
  }

  public DBObject makeNew(String name, String folder, int id)
  {
    if (name.compareTo("scores") == 0)
      return new Score(folder, id);
    return null;
  }

  public void load()
  {
    InputStream in = getInputStream(folder, id);
    Properties prop = new Properties();
    try {
      prop.load(in);
    } catch (IOException str) {
      return;
    }
    scores = getTable(prop, "scores", folder);
    name.loadProperties(prop, "name");
    description.loadProperties(prop, "description");
    day.loadProperties(prop, "day");
    try { in.close(); } catch (IOException str) {};
  }

  public void save(DBObject value)
  {
    OutputStream out = getOutputStream(folder, id);
    Properties prop = new Properties();
    setTable(scores, prop, "scores");
    name.saveProperties(prop, "name");
    description.saveProperties(prop, "description");
    day.saveProperties(prop, "day");
    prop.save(out, "TrackTrek '97 by Steven Lawrance  Event");
    try { out.close(); } catch (IOException str) {};
  }
}
