// Participant.java

package sl.TrackTrek;

import sl.TrackTrek.DBObject;
import sl.TrackTrek.DateType;
import sl.TrackTrek.StringType;
import sl.TrackTrek.DBPointer;
import java.util.Properties;
import java.util.Hashtable;
import java.io.*;

public class Participant extends DBObject
{
  public Hashtable events;
  public Hashtable teams;
  public Hashtable trackMeet;
  public int id;
  public String folder;
  public StringType name;
  public StringType description;

  public Participant(String folder, int id)
  {
    this.id = id;
    this.folder = folder + File.pathSeparator + "Participant" + String.valueOf(id);
  }

  public DBObject makeNew(String name, String folder, int id)
  {
    if (name.compareTo("events") == 0)
      return new DBPointer(folder, id, name);
    if (name.compareTo("teams") == 0)
      return new DBPointer(folder, id, name);
    if (name.compareTo("participants") == 0)
      return new DBPointer(folder, id, name);
    return null;
  }

  public void load()
  {
    InputStream in = getInputStream(folder, id);
    Properties prop = new Properties();
    try {
      prop.load(in);
    } catch (IOException str) {
      return;
    }
    events = DBPointer.getTable(prop, "events", folder);
    teams = DBPointer.getTable(prop, "teams", folder);
    trackMeet = DBPointer.getTable(prop, "trackMeet", folder);
    name.loadProperties(prop, "name");
    description.loadProperties(prop, "description");
    try { in.close(); } catch (IOException str) {};
  }

  public void save(DBObject value)
  {
    OutputStream out = getOutputStream(folder, id);
    Properties prop = new Properties();
    setTable(events, prop, "events");
    setTable(teams, prop, "teams");
    setTable(participants, prop, "participants");
    setTable(trackMeet, prop, "trackMeet");
    name.saveProperties(prop, "name");
    description.saveProperties(prop, "description");
    prop.put("trackMeetId", String.valueOf(trackMeetId));
    prop.save(out, "TrackTrek '97 by Steven Lawrance  Participant");
    try { out.close(); } catch (IOException str) {};
  }
}
