// Root.java

package sl.TrackTrek;

import sl.TrackTrek.DBObject;
import sl.TrackTrek.TrackMeet;
import sl.TrackTrek.Team;
import java.util.Properties;
import java.util.Hashtable;
import java.io.*;

public class Root extends DBObject
{
  public Hashtable trackMeets;
  public Hashtable teams;
  public int id;
  public String folder;

  public Root(String folder, int id)
  {
	 this.id = id;
	 this.folder = folder + File.pathSeparator + "Root" + String.valueOf(id);
  }

  public DBObject makeNew(String name, String folder, int id)
  {
	 if (name.compareTo("trackMeet") == 0)
		return new TrackMeet(folder, id);
	 if (name.compareTo("teams") == 0)
		return new Team(folder, id);
	 return null;
  }

  public void load()
  {
	 InputStream in = getInputStream(folder, id);
	 Properties prop = new Properties();
	 try {
		prop.load(in);
	 } catch (IOException str) {
		return;
	 }
	 trackMeet = getTable(prop, "trackMeet");
	 teams = getTable(prop, "teams", folder);
	 in.close();
  }

  public void save(DBObject value)
  {
	 OutputStream out = getOutputStream(folder, id);
	 Properties prop = new Properties();
	 setTable(trackMeet, prop, "trackMeet");
	 setTable(teams, prop, "teams");
	 prop.save(out, "TrackTrek '97 by Steven Lawrance  Root");
	 try { out.close(); } catch (IOException str) {};
  }
}

