// Score.java

package sl.TrackTrek;

import sl.TrackTrek.DBObject;
import sl.TrackTrek.StringType;
import sl.TrackTrek.TimeType;
import sl.TrackTrek.Distance;
import java.util.Properties;
import java.util.Hashtable;
import java.io.*;


public class Score extends DBObject
{
  public static int SCORE_DISTANCE = 1;
  public static int SCORE_TIME     = 2;

  public DataType score;
  public int id;
  public String folder;
  public DBPointer participant;
  public int scoreType;

  public Score(String folder, int id)
  {
    this.id = id;
    this.folder = folder + File.pathSeparator + "Scores";
  }

  public DBObject makeNew(String name, String folder, int id)
  {
    // We have no children; return a null pointer
    // note: visiting relatives sux!!
    return null;
  }

  public void load()
  {
    InputStream in = getInputStream(folder, id);
    Properties prop = new Properties();
    try {
      prop.load(in);
    } catch (IOException str) {
      return;
    }
    scoreType = Integer.getInteger(prop.getProperty("scoreType", "1")).intValue();
    participant = new DBPointer(folder, Integer.getInteger(prop.getProperty("participant", "-1")).intValue(), "participant");

    // And now for the whole purpose of this object: get the score
    score = null;
    if (scoreType == SCORE_DISTANCE)
      score = new Distance(Integer.getInteger(prop.getProperty("score", "0")).intValue());
    if (scoreType == SCORE_TIME)
      score = new TimeType(Integer.getInteger(prop.getProperty("score", "0")).intValue());

    try { in.close(); } catch (IOException str) {};
  }

  public void save(DBObject value)
  {
    OutputStream out = getOutputStream(folder, id);
    Properties prop = new Properties();
    prop.put("scoreType", String.valueOf(scoreType));
    prop.put("participant", String.valueOf(participant));
    prop.put("score", score.getStringValue());
    prop.save(out, "TrackTrek '97 by Steven Lawrance  Score");
    try { out.close(); } catch (IOException str) {};
  }
}

