// TrackTrek StringType data type
// StringType.java
// By Steven Lawrance

package sl.TrackTrek;
import java.lang.*;
import java.util.Properties;

public class StringType extends sl.TrackTrek.DataType
{
  // Value for this object
  public String value;

  // Default sort behavior
  public static boolean normallyAscend = true;

  public StringType(String value)
  {
      super();
	 this.value = new String(value);
  }

  public StringType()
  {
      super();
	 value = new String();
  }

  public String toString()
  {
	 // Return ourselves :-)
	 return new String(value);
  }

  public int compareTo(DataType other)
  {
	 // Get the number of minutes in both dates
	 String otherValue = (other.getStringValue()).toLowerCase();
	 String thisValue = value.toLowerCase();

	 // Call the string's compareTo function and return that
	 return thisValue.compareTo(otherValue);
  }

  public long getLongValue()
  {
	 return Long.parseLong(value);
  }

  public String getStringValue()
  {
	 return new String(this.value);
  }

  public void setValue(long value)
  {
	 // Set the value
	 this.value = (new Long(value)).toString();
  }

  public void setValue(String value)
  {
	 this.value = new String(value);
  }

  public void loadProperties(Properties prop, String name)
  {
    value = prop.getProperty(name + ".value", null);
    normallyAscend = Boolean.getBoolean(prop.getProperty(name + ".normallyAscend", "true"));
  }

  public void saveProperties(Properties prop, String name)
  {
    prop.put(name + ".value", value);
    prop.put(name + ".normallyAscend", String.valueOf(normallyAscend));
  }
}


