// Team.java
package sl.TrackTrek;

import sl.TrackTrek.DBObject;
import sl.TrackTrek.Event;
import sl.TrackTrek.Team;
import sl.TrackTrek.Participant;
import sl.TrackTrek.DateType;
import sl.TrackTrek.StringType;
import java.util.Properties;
import java.util.Hashtable;
import java.io.*;

public class Team extends DBObject
{
  public Hashtable events;
  public Hashtable teams;
  public Hashtable participants;
  public int id;
  public String folder;
  public DateType day;
  public StringType name;
  public StringType description;

  public TrackMeet(String folder, int id)
  {
	 this.id = id;
	 this.folder = folder + File.pathSeparator + "TrackMeet" + String.valueOf(id);
  }

  public DBObject makeNew(String name, String folder, int id)
  {
	 if (name.compareTo("events") == 0)
		return new Event(folder, id);
	 if (name.compareTo("participants") == 0)
		return new Participant(folder, id);
	 return null;
  }

  public void load()
  {
    InputStream in = getInputStream(folder, id);
    Properties prop = new Properties();
    try {
      prop.load(in);
    } catch (IOException str) {
      return;
    }
    events = getTable(prop, "events", folder);
    teams = getTable(prop, "teams", folder);
    participants = getTable(prop, "participants", folder);
    name.loadProperties(prop, "name");
    description.loadProperties(prop, "description");
    day.loadProperties(prop, "day");
    try { in.close(); } catch (IOException str) {};
  }

  public void save(DBObject value)
  {
    OutputStream out = getOutputStream(folder, id);
    Properties prop = new Properties();
    setTable(events, prop, "events");
    setTable(teams, prop, "teams");
    setTable(participants, prop, "participants");
    name.saveProperties(prop, "name");
    description.saveProperties(prop, "description");
    day.saveProperties(prop, "day");
    prop.save(out, "TrackTrek '97 by Steven Lawrance  Team");
    try { out.close(); } catch (IOException str) {};
  }
}
