package sl.TrackTrek ;

import w3c.jigsaw.http.*;
import w3c.jigsaw.resources.*;

import w3c.jigsaw.html.* ;
import w3c.jigsaw.forms.*;

import sl.TrackTrek.Page;

public class Edit extends PostableResource {

	// The message attribute index
	protected static int ATTR_MESSAGE = -1 ;
	// The headers attribute index
	protected static int ATTR_HEADERS = -1 ;

	static {
		Attribute a   = null ;
		Class     cls = null ;

		try {
			cls = Class.forName("sl.TrackTrek.Edit");
		} catch (Exception ex) {
			ex.printStackTrace() ;
			System.exit(1) ;
		}
		// Register the message attribute:
		a = new StringAttribute("track database", "/jigsaw/classes/sl/TrackTrek/main.track-database", Attribute.EDITABLE);
		ATTR_MESSAGE = AttributeRegistery.registerAttribute(cls, a) ;
		// Register the headers attribute:
		a = new StringArrayAttribute("login message", null, Attribute.EDITABLE) ;
		ATTR_HEADERS = AttributeRegistery.registerAttribute(cls, a) ;
	}

	/**
	 * Display the resource message with the request headers.
	 * @param request The request to handle.
	 * @exception HTTPException If processing the request failed.
	 */

	public Reply get(Request request)
		throws HTTPException
	{
		if (request.getQueryString("SortOrder=").startsWith("SortOrder="))
		{
		  // Create the HTML generator, and set titles:
		  HtmlGenerator g = new HtmlGenerator("TrackTrek 1.02");
		  String content[][] = new String[6][3];
		  String label[] = new String[3];
		  String queryString = request.getQueryString("1");
		  int x1, x2;
		  int sortOrder = (Integer.valueOf(queryString.substring(queryString.length() - 1))).intValue();
		  sl.TrackTrek.Page.header(g, "Welcome to TrackTrek!");

		  label[0] = "Participant:";
		  label[1] = "GPA:";
		  label[2] = "Politeness:";
		  content[0][0] = "Steven Lawrance";
		  content[0][1] = "5.123";
		  content[0][2] = "high";
		  content[1][0] = "Chris Everett";
		  content[1][1] = "5.103";
		  content[1][2] = "low";
		  content[2][0] = "Alan Donaldson";
		  content[2][1] = "4.502";
		  content[2][2] = "high";
		  content[3][0] = "Mike Crockett";
		  content[3][1] = "5.203";
		  content[3][2] = "moderate";
		  content[4][0] = "Jeff Maars";
		  content[4][1] = "5.334";
		  content[4][2] = "low";
		  content[5][0] = "Steven Lawrance";
		  content[5][1] = "5.121";
		  content[5][2] = "high";

		  sl.TrackTrek.Page.table(g, content, label, 6, 3, "Edit", sortOrder, "Edit", "Destroy the universe!!!");
/*		  g.append("<h1>Welcome to TrackTrek!</h1>");

		  g.append("<h1>Untitled Form Page</h1>\n");
		  g.append("<hr>\n");
		  g.append("<p>This is an explanation of the purpose of the form ...</p>\n");
		  g.append("<form action=\"Edit\" method=\"GET\">\n");
		  g.append("<p>Please provide the following contact information:</p>\n");
		  g.append("<blockquote>\n");
		  g.append("<pre><em>            Name </em><input type=text size=35 maxlength=256 name=\"name\">\n");
		  g.append("<em>           Title </em><input type=text size=35 maxlength=256 name=\"title\">\n");
		  g.append("<em>    Organization </em><input type=text size=35 maxlength=256 name=\"org\">\n");
		  g.append("<em>      Work Phone </em><input type=text size=25 maxlength=25 name=\"workphone\">\n");
		  g.append("<em>             FAX </em><input type=text size=25 maxlength=25 name=\"fax\">\n");
		  g.append("<em>          E-mail </em><input type=text size=25 maxlength=256 name=\"email\">\n");
		  g.append("<em>             URL </em><input type=text size=25 maxlength=256 name=\"url\">\n");
		  g.append("</pre>\n");
		  g.append("</blockquote>\n");
		  g.append("<p>Enter your cat's name in the space provided below.</p>\n");
		  g.append("<blockquote>\n");
		  g.append("<p><input type=text size=35 maxlength=256 name=\"cats\"> <br>\n");
		  g.append("</p>\n");
		  g.append("</blockquote>\n");
		  g.append("<p><input type=submit value=\"Submit Form\"> <input type=reset value=\"Reset Form\"> </p>\n");
		  g.append("</form>\n");
		  g.append("<hr>\n");
		  g.append("<h5>Copyright information goes here.<br>\n");
		  g.append("Last revised: <!--VERMEER\n");
		  g.append("   BOT=TimeStamp\n");
		  g.append("   S-Type=\"EDITED\"\n");
		  g.append("   S-Format=\"%B %d, %Y\"\n");
		  g.append(" --></h5>\n");

		  // Emit the message:
		  g.append("<p>"+getValue(ATTR_MESSAGE, null));
		  // Now emit the requested headers:
		  String headers[] = (String[]) getValue(ATTR_HEADERS, null) ;
		  if ( headers != null ) {
			 g.append("<hr><h2>Request headers:</h2><dl>");
			 for (int i = 0 ; i < headers.length ; i++) {
				g.append("<dt>"+headers[i]+"</dt><dd>");
				String value = request.getField(headers[i]);
				g.append((value == null)
					 ? "<em>undefined</em>"
					 : request.getField(headers[i])) ;
			 }
		  }*/


		  Reply reply = request.makeReply(HTTP.OK) ;
		  reply.setStream(g) ;
		  return reply ;
		}
		else
		{
		  String cmdLine = request.getQueryString();

		  HtmlGenerator g = new HtmlGenerator("TrackTrek 1.02 (posted!)");
		  g.append("<h1>Welcome to TrackTrek! posted!</h1>");
		  g.append("\n\nQuery String: ");
		  g.append(((cmdLine == "")? "<em>none</em>" : cmdLine) + "\n\n");
		  Reply reply = request.makeReply(HTTP.OK) ;
		  reply.setStream(g) ;
		  return reply ;
		}
	}
	public Reply post(Request request)
		throws HTTPException
	{
		// Create the HTML generator, and set titles:
		HtmlGenerator g = new HtmlGenerator("TrackTrek 1.02 (posted!)");
		g.append("<h1>Welcome to TrackTrek! posted!</h1>");
		// Emit the message:
				g.append("hello!");
		g.append("<p>"+getValue(ATTR_MESSAGE, null));
		// Now emit the requested headers:
				g.append("hello!");
/*		String headers[] = (String[]) getValue(ATTR_HEADERS, null) ;
		if ( headers != null ) {
			g.append("<hr><h2>Request headers:</h2><dl>");
			for (int i = 0 ; i < headers.length ; i++) {
				g.append("<dt>"+headers[i]+"</dt><dd>");
				String value = request.getField(headers[i]);
				g.append((value == null)
					 ? "<em>undefined</em>"
					 : request.getField(headers[i])) ;
			}
		}*/
				g.append("hello!");
/*				String value = request.getField("cats");
				g.append((value == null)
					 ? "<em>undefined</em>"
					 : request.getField("cats")) ;*/
				g.append("\n\nQuery String: ");
				g.append(request.getQueryString("[none]")+"\n\n");
				g.append("The name of your really cute furry fluffy feline: ");
				try
				{
				  g.append(request.getFieldString("cats") + "\n\n");
				} catch (w3c.mime.MIMEException msg) { g.append("sorry..."); }
		Reply reply = request.makeReply(HTTP.OK) ;
		reply.setStream(g) ;
		return reply ;
	}

}

